#include "stack.h"

nodo_label *create_nodo(nodo_label *new_nodo);

stack_label *create_stack(stack_label *new_stack)
{
   /*handle creation */	

   new_stack=(stack_label *)malloc(sizeof(stack_label));
   if(!new_stack) exit(1);   /* memory allocation check */
   new_stack->link_pila=NULL;
   new_stack->num_val=0;
   return new_stack;
}

nodo_label *create_nodo(nodo_label *new_nodo)
{
       /* node creation */
       new_nodo=(nodo_label *)malloc(sizeof(nodo_label));	
       if(!new_nodo) exit(1); /*memory allocation check */
       new_nodo->next=NULL;
       new_nodo->info=0;
       return new_nodo;
}

void push(stack_label *new_stack, void* val)
{
	nodo_label *tmp, *tmp_testa;
	tmp=create_nodo(tmp);
	tmp->info=val;

	tmp_testa=new_stack->link_pila; /* pointer of stack head */

	if(isempty(new_stack)) { new_stack->link_pila=tmp;
		                 new_stack->num_val=1;
	                       }
	else {
		tmp->next=tmp_testa;
		new_stack->link_pila=tmp;
		new_stack->num_val += 1;
	     }
}

void* pop(stack_label *new_stack)
{
	nodo_label *tmp;
	void* val;
	
	if(isempty(new_stack)) exit(1);

	tmp=new_stack->link_pila;
	val=new_stack->link_pila->info;

	new_stack->link_pila=new_stack->link_pila->next;
	new_stack->num_val--;
	free(tmp);
	
	return val;
}

void* top(const stack_label *new_stack)
{
	return (new_stack->link_pila->info);
}
	
int isempty(const stack_label *new_stack)
{
	if(!new_stack->link_pila) return 1;
	else return 0;
}

void free_stack(stack_label *new_stack)
{
	free(new_stack);
}
